const defaults = require("./defaults.json");

function uniq(pArray) {
  return [...new Set(pArray)];
}

function normalizeFilterOption(pFilterOption) {
  const lFilterOption = pFilterOption || {};

  if (typeof lFilterOption === "string") {
    return {
      path: lFilterOption
    };
  }
  return lFilterOption;
}

module.exports = pOptions => {
  let lReturnValue = {
    baseDir: process.cwd(),
    ...defaults,
    ...pOptions
  };

  lReturnValue.maxDepth = parseInt(lReturnValue.maxDepth, 10);
  lReturnValue.moduleSystems = uniq(lReturnValue.moduleSystems.sort());
  lReturnValue.doNotFollow = normalizeFilterOption(lReturnValue.doNotFollow);
  lReturnValue.exclude = normalizeFilterOption(lReturnValue.exclude);
  lReturnValue.exoticRequireStrings = uniq(
    lReturnValue.exoticRequireStrings.sort()
  );

  return lReturnValue;
};
